package org.diagbot.common.push.filter;


import org.diagbot.common.push.filter.pretreat.Pretreatment;
import org.diagbot.common.push.filter.pretreat.PretreatmentSymptom;
import org.diagbot.common.push.filter.pretreat.PretreatmentVital;
import org.diagbot.common.work.SearchData;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

public class PretreatmentFilter {
    public void crisisFilter(SearchData searchData) throws java.io.IOException {
        //将数值类型内容全部转换为标准术语  依据kl_rule提供规则

        List<PreResult> allPreResultList = new ArrayList<>();
        //症状数据
        if (!StringUtils.isEmpty(searchData.getSymptom())) {
            searchData.setSymptom(add2PreResultList(new PretreatmentSymptom(), searchData.getSymptom(), allPreResultList));
        }
        //体征数据
        if (!StringUtils.isEmpty(searchData.getVital())) {
            searchData.setVital(add2PreResultList(new PretreatmentVital(), searchData.getVital(), allPreResultList));
        }
        //lis文本非结构化数据
        if (!StringUtils.isEmpty(searchData.getLis())) {
            searchData.setLis(add2PreResultList(new PretreatmentVital(), searchData.getLis(), allPreResultList));
        }
        //pacs数据
        if (!StringUtils.isEmpty(searchData.getPacs())) {
            searchData.setPacs(add2PreResultList(new PretreatmentVital(), searchData.getPacs(), allPreResultList));
        }
    }

    private String add2PreResultList(Pretreatment pretreatment, String content, List<PreResult> allPreResultList) throws java.io.IOException {
        List<PreResult> preResultList = pretreatment.analyze(content);
        if (preResultList != null) {
            allPreResultList.addAll(preResultList);


        }
        return content;
    }
}
